#pragma once

#include <map>
#include <vector>

// Base Class
#include "../Filter.h"

// Aron
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

namespace armarx::armem::server::ltm::processor::filter
{
    class SnapshotSimilarityFilter : public SnapshotFilter
    {
    public:
        static const constexpr char* NAME = "SnapshotSimilarityFilter";

        SnapshotSimilarityFilter() = default;

        virtual bool accept(const armem::wm::EntitySnapshot& e) override;

    public:
        // TODO link aron/similarity

    private:
        std::map<MemoryID, std::vector<aron::data::DictPtr>> dataLastCommit;
        std::map<MemoryID, long> timestampLastCommitInMs;
    };
} // namespace armarx::armem::server::ltm::processor::filter
