#include "ProviderID.h"

#include "SkillID.h"

namespace armarx
{
    namespace skills
    {
        ProviderID::ProviderID(const std::string& pname) : providerName(pname)
        {
        }

        ProviderID::ProviderID(const skills::SkillID& skillid)
        {
            ARMARX_CHECK(skillid.providerId.has_value());
            providerName = skillid.providerId->providerName;
        }

        bool
        ProviderID::operator==(const ProviderID& other) const
        {
            return providerName == other.providerName;
        }

        bool
        ProviderID::operator!=(const ProviderID& other) const
        {
            return not(*this == other);
        }

        bool
        ProviderID::operator<(const ProviderID& other) const
        {
            return toString() < other.toString();
        }

        ProviderID
        ProviderID::FromIce(const manager::dto::ProviderID& s)
        {
            return ProviderID(s.providerName);
        }

        ProviderID
        ProviderID::FromIce(const callback::dto::ProviderID& s)
        {
            return ProviderID(s.providerName);
        }

        manager::dto::ProviderID
        ProviderID::toManagerIce() const
        {
            return {providerName};
        }

        callback::dto::ProviderID
        ProviderID::toCallbackIce() const
        {
            return {providerName};
        }

        std::string
        ProviderID::toString(const std::string& prefix) const
        {
            return (prefix.empty() ? std::string("") : (prefix + PREFIX_SEPARATOR)) + providerName;
        }
    } // namespace skills

    std::ostream&
    skills::operator<<(std::ostream& os, const ProviderID& id)
    {
        return os << "'" << id.toString() << "'";
    }
} // namespace armarx
