#pragma once

#include <string>
#include <vector>

#include <RobotAPI/interface/skills/SkillProviderInterface.h>
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

namespace armarx
{
    namespace skills
    {
        struct SkillParameterization
        {
            SkillParameterization() = delete;

            SkillParameterization(const aron::data::DictPtr& params,
                                  const callback::dti::SkillProviderCallbackInterfacePrx& i) :
                parameterization(params), callbackInterface(i)
            {
            }

            static SkillParameterization
            FromIce(const armarx::aron::data::dto::DictPtr& params,
                    const callback::dti::SkillProviderCallbackInterfacePrx& i)
            {
                return SkillParameterization(armarx::aron::data::Dict::FromAronDictDTO(params), i);
            }

            aron::data::DictPtr parameterization;
            callback::dti::SkillProviderCallbackInterfacePrx callbackInterface;
        };
    } // namespace skills
} // namespace armarx
