#include "SimpleSkill.h"

namespace armarx::skills
{
    Skill::InitResult
    SimpleSKill::init()
    {
        InitInput i;
        i.executorName = this->executorName;
        i.params = this->parameters;
        return this->init(i);
    }

    Skill::MainResult
    SimpleSKill::main()
    {
        MainInput i;
        i.executorName = this->executorName;
        i.params = this->parameters;
        i.callback = this->callback;
        return this->main(i);
    }

    Skill::ExitResult
    SimpleSKill::exit()
    {
        ExitInput i;
        i.executorName = this->executorName;
        i.params = this->parameters;
        return this->exit(i);
    }

    Skill::InitResult
    SimpleSKill::init(const InitInput& in)
    {
        // Default nothing to init
        return {.status = TerminatedSkillStatus::Succeeded};
    }

    Skill::MainResult
    SimpleSKill::main(const MainInput& in)
    {
        // This is just a dummy implementation
        ARMARX_IMPORTANT << "Dummy executing skill '" << description.skillId
                         << "'. Please overwrite this method.";
        return {.status = TerminatedSkillStatus::Succeeded, .data = nullptr};
    }

    Skill::ExitResult
    SimpleSKill::exit(const ExitInput& in)
    {
        // Default nothing to exit
        return {.status = TerminatedSkillStatus::Succeeded};
    }
} // namespace armarx::skills
