#pragma once

#include <RobotAPI/libraries/skills/core/Skill.h>

namespace armarx
{
    namespace skills
    {
        class SimpleSKill : public Skill
        {
        public:
            using Skill::Skill;

            struct InitInput
            {
                std::string executorName;
                aron::data::DictPtr params;
            };

            struct MainInput
            {
                std::string executorName;
                aron::data::DictPtr params;
                CallbackT callback;
            };

            struct ExitInput
            {
                std::string executorName;
                aron::data::DictPtr params;
            };


        protected:
            // legacy methods
            virtual InitResult init(const InitInput& in);
            virtual MainResult main(const MainInput& in);
            virtual ExitResult exit(const ExitInput& in);

            InitResult init() final;
            MainResult main() final;
            ExitResult exit() final;

        private:
        };
    } // namespace skills
} // namespace armarx
